#include "solvers.h"

INT main(int argc, char* argv[]) {
/********** MAIN PROGRAM *********************************
 * Solve Laplace equation using Jacobi iteration method  *
 * Kadin Tseng, Boston University, August, 2000          *
 *********************************************************/
      INT iter, m, mi, mp;
      REAL gdel; 
      REAL **u, **un;
      mi=28;
      if(argc>1)
         (void) sscanf(argv[1], "%d", &mi);
      fprintf(OUTPUT,"mi = %d\n",mi);

      m = mi + 2;   /* ineterior points plus 2 b.c. points */
      mp = m/P;

      u  = allocate_2D(m, mp);  /* allocate mem for 2D array */
      un = allocate_2D(m, mp);

      gdel = 1.0;
      iter = 0;

      bc(m, mp, u, K, P); /* initialize and define B.C. for u */

      replicate(m, mp, u, un);   /* u = un */

      while (gdel > TOL) {  /* iterate until error below threshold */
        iter++;             /* increment iteration counter */

        if(iter > MAXSTEPS) {
          fprintf(OUTPUT,"Iteration terminated (exceeds %6d", MAXSTEPS);
          fprintf(OUTPUT," )n");
          return (0);       /* nonconvergent solution */
        }
/* compute new solution according to the Jacobi scheme */
        update_jacobi(m, mp, u, un, &gdel);

        if(iter%INCREMENT == 0) {
          fprintf(OUTPUT,"iter,gdel: %6d, %f\n",iter,gdel);
        }
      }

      fprintf(OUTPUT,"Stopped at iteration %d\n",iter);
      fprintf(OUTPUT,"The maximum error = %f\n",gdel);

      write_gnuplot(m,mp,u);
      return (0);
}

